Loading...
Searching...
No Matches
Utilities
Common

Collection of helper classes, type traits, etc. More...

Collaboration diagram for Utilities:

## Topics

| Filesystem Paths
| Utilities for filesystem path management.
| Range Utilities
| Utilities for reduction like operations on ranges.
| String Utilities
| Utility functions for std::string.
| Tuple Utilities
| Utility classes which can be used with std::tuple.
| Type Utilities
| Type traits, overload helpers, and other utilities for type computations.
| Hybrid Utilities
| Hybrid utility functions that work on homogeneous as well as heterogeneous containers.
| C++ utilities and backports
| Standard library features backported from newer C++ versions or technical specifications and DUNE-specific utilities.
| C++ concepts
| Concepts definitions and utilities to define requirements.

## Classes

class | Dune::TupleVector< T >
| A class augmenting std::tuple by element access via operator[]. More...

## Typedefs

template<class T>
using | Dune::ResolveRef_t = std::remove_reference_t<decltype(Dune::resolveRef(std::declval<T&>()))>
| Type trait to resolve std::reference_wrapper.

## Functions

template<class F, class ArgTuple, class I, I... i>
decltype(auto) | Dune::applyPartial (F &&f, ArgTuple &&args, std::integer_sequence< I, i... >)
| Apply function with arguments from a given tuple.

## Detailed Description

Collection of helper classes, type traits, etc.

## Typedef Documentation

## ResolveRef_t

template<class T>

using Dune::ResolveRef_t = std::remove_reference_t<decltype(Dune::resolveRef(std::declval<T&>()))>

Type trait to resolve std::reference_wrapper.

This is an alias for result of resolveRef. Plain types T or const T are forwarded while for T=std::reference_wrapper<S> the wrapped type S is returned.

## Function Documentation

## applyPartial()

template<class F, class ArgTuple, class I, I... i>

decltype(auto) Dune::applyPartial | ( | F && | f,
|  | ArgTuple && | args,
|  | std::integer_sequence< I, i... > | )

Apply function with arguments from a given tuple.

Parameters

  f | A callable object
  args | Tuple containing the arguments
  indices | Indices to arguments in tuple as std::integer_sequence

This will call the function with arguments generated by unpacking those entries of the tuple that show up given integer_sequence.